#include <bits/stdc++.h>
using namespace std;

#define xx first
#define yy second

typedef long long ll;
typedef pair<int, int> ii;

int n, m;
int a, b;

const int P = 998244353;

vector<ii> beams = {
    ii(0, 1), ii(1, 1), ii(1, 2),
    ii(1, 3), ii(1, 4), ii(2, 3),
};

vector<int> dxy { +1, +1, -1, -1, +1 };

vector<vector<int>> mul (5, vector<int>(4));

vector<vector<int>> mem (5*4, vector<int>(1<<20, -1));

ll solve(int u, int used) {
    int i = u/4, j = u%4;
    if (__builtin_popcount(used) == b) { return mul[i][j]; }
    if (mem[u][used] != -1) { return mem[u][used]; }

    ll ans = (__builtin_popcount(used) >= a);

    for (int k = 0; k < 4; k++) {
        int ddi = dxy[k], ddj = dxy[k+1];
        for (int b = 0; b < beams.size(); b++) {
            int bdi = beams[b].xx, bdj = beams[b].yy;
            for (int s = 0; s < 2; s++) {
                if (b == 0 && s == k%2) { continue; }
                if (s == 1) {
                    if (bdi == bdj) { continue; }
                    swap(bdi, bdj);
                }

                int di = bdi*ddi;
                int dj = bdj*ddj;
                while (0 <= i+di && i+di < n && 0 <= j+dj && j+dj < m) {
                    int adj = 4*(i+di)+(j+dj);
                    if (!(used & (1<<adj))) {
                        ans += solve(adj, used | (1<<adj));
                        ans %= P;
                        break;
                    }
                    di += bdi*ddi;
                    dj += bdj*ddj;
                }
            }
        }
    }

    ans *= mul[i][j];
    ans %= P;
    return mem[u][used] = ans;
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    cin >> n >> m;

    for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
        if (m == 5) {
            cin >> mul[j][i];
        } else {
            cin >> mul[i][j];
        }
    }
    }

    if (m == 5) { swap(n, m); }

    cin >> a >> b;

    ll s = 0;

    for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
        int u = 4*i+j;
        s += solve(u, 1<<u);
    }
    }

    cout << s << "\n";
}
